import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:osam/osam.dart';

void main() async {
  final core = Core();
  final sc = StreamController.broadcast();
  final s1 = sc.stream;
  final s2 = sc.stream;

  print(s1 == s2);

  runApp(MaterialApp(
    home: App(core),
  ));
}

class App extends StatefulWidget {
  final Core core;

  const App(this.core);

  @override
  _AppState createState() => _AppState();
}

class _AppState extends State<App> {
  bool isVisible = true;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      floatingActionButton: FloatingActionButton(
        onPressed: () {
          widget.core.update((state) {
            state.news
              ..clear()
              ..add(News(0));
          });
        },
      ),
      body: OsamBuilder<List<News>>(
        stream: widget.core.propertyStream((state) => state.news),
        builder: (ctx, value) {
          return ListView(
            children: value.map((e) {
              return OsamBuilder<bool>(
                key: ValueKey(e.id),
                stream: e.propertyStream((state) => state.isFavorite),
                builder: (ctx, value) {
                  return GestureDetector(
                    child: Icon(value ? Icons.plus_one : Icons.minimize),
                    onTap: () {
                      e.update((state) => state.isFavorite = !value);
                    },
                  );
                },
              );
            }).toList(),
          );
        },
      ),
    );
  }
}

// ignore: must_be_immutable
class Core extends BaseState<Core> {
  var news = <News>[News(0), News(1), News(2)];

  @override
  List<Object> get props => [news];
}

// ignore: must_be_immutable
class News extends BaseState<News> {
  bool isFavorite = false;
  final int id;

  News(this.id);

  @override
  List<Object> get props => [isFavorite, id];
}
